$TITLE KUOSMANENOV TEST NA REALNE DATA
$offsymxref offsymlist offuelxref offuellist onlisting;
options limcol=0;
options limrow=0;
options decimals = 8;
options solprint = off;
*okienko urcuje kolko riadkovu maticu vyberam 120 riadkov po mesiaci = 10 rokov
parameter okienko /120/;
*skok urcuje kolko riadkov preskocim kym vyberiem dalsei okienko 12 riadkov = 1 rok
parameter skok /12/;
set vysledkov /1 * 73/;
* indexy riadkov vybranej matice - je treba aby ich bolo tolko ako je velkost okienka
set riadky /riadok1 * riadok120/;
alias(riadky,ind);
parameter te pocet scenarov v aktualnej ulohe;
te=card(riadky);

set scenare mnozina scenarov;
set aktiva mnozina aktiv;

* nacitanie dat z Excelu
$call Gdxxrw Industry_portfolios_upravene.xls set=scenare Rng=a2:a975 rdim=1 set=aktiva Rng=b1:l2 cdim=1 par=vynos Rng=a1:l975 cdim=1 rdim=1 par=tau Rng=a976 rdim=1
$gdxin Industry_portfolios_upravene.gdx
$load scenare
$load aktiva
parameter vynos(scenare, aktiva) nadvynosy v jednotlivych odvetviach = nadvynosy urcitych aktiv za platnosti scenarov;
$load vynos
parameter tau(scenare) nadvynosy trzneho portfolia;
$load tau
$gdxin

* pomocne premenne
parameter matica(riadky,aktiva);
parameter xjtau(riadky) vektor vynosov pri t roznych scenaroch;

* zapis modelu ...
positive variables lambda(aktiva) vysledne SSD dominujuce portfolio;
variable thetan hodnota ucelovej funkcie;
positive variables w(riadky,ind) matica W t krat t;

equations
   obmedzenieprve(riadky) prve obmedzenie v kuosmanenovom teste;
equations
   stlpcew(ind)   sucet v stlpcoch W je jedna;
equations
   riadkyw(riadky)   sucet v riadkoch W je jedna;
equations
   sucetlambda     sucet lambda je jedna;
equations thetan1 ucelova funkcia;


thetan1..  thetan =e= sum(riadky, sum(aktiva, matica(riadky, aktiva)*lambda(aktiva))-xjtau(riadky))/te;
obmedzenieprve(riadky)..  sum(aktiva, matica(riadky, aktiva)*lambda(aktiva)) =g= sum(ind, w(riadky, ind)*xjtau(ind));
stlpcew(ind)..  sum(riadky, w(riadky, ind)) =e= 1;
riadkyw(riadky)..  sum(ind, w(riadky, ind)) =e= 1;
sucetlambda..    sum(aktiva, lambda(aktiva)) =e= 1;

model kuosmanen Kuosmanenovo nutne ktiterium eficiencie portfolia /all/;

* pomocne parametre, ktore su potrebne pri vybere jednotlivych podmatic a riesenie ulohy pre tuto podmaticu
parameter vysledok(vysledkov);
parameter lambdavysl(vysledkov,aktiva);
parameter ktory;
parameter v;
parameter j;
parameter i;
parameter k;
v=0;
i=1;
while (i+okienko-1 <= card(scenare),
         ktory = i;
         j=0;
         loop(scenare,
               j=j+1;
               if (j=ktory,
                       k=0;
                       loop(riadky,
                               matica(riadky,aktiva) = vynos(scenare+k,aktiva);
                               xjtau(riadky) = tau(scenare+k);
                       k=k+1;
                       );
               );
         );

solve kuosmanen maximizing thetan using lp;
loop(vysledkov,vysledok(vysledkov+(i-1-(skok-1)*v))=thetan.l);
loop(vysledkov,lambdavysl(vysledkov+(i-1-(skok-1)*v),aktiva)=lambda.l(aktiva));
         i=i+skok;
         v=v+1;
);

* zapis vysledkov do Excelu
execute_unload "Kuosmanen_miera.gdx" vysledok;
execute 'Gdxxrw.exe Kuosmanen_miera.gdx par=vysledok Rng=a1';
execute_unload "Kuosmanen_lambda.gdx"  lambdavysl;
execute 'Gdxxrw.exe Kuosmanen_lambda.gdx par=lambdavysl Rng=a1';