$TITLE POSTOV TEST - PRIMARNA ULOHA NA REALNE DATA
$offsymxref offsymlist offuelxref offuellist onlisting;
options limcol=0;
options limrow=0;
options decimals = 8;
options solprint = off;
*okienko urcuje kolko riadkovu maticu vyberam 120 riadkov po mesiaci = 10 rokov
parameter okienko /120/;
*skok urcuje kolko riadkov preskocim kym vyberiem dalsei okienko 12 riadkov = 1 rok
parameter skok /12/;
set vysledkov /1 * 73/;
* indexy riadkov vybranej matice - je treba aby ich bolo tolko ako je velkost okienka
set riadky /riadok1 * riadok120/;
parameter te pocet scenarov v aktualnej ulohe;
te=card(riadky);

set scenare mnozina scenarov;
set aktiva mnozina aktiv;

* nacitanie dat z Excelu
$call Gdxxrw Industry_portfolios_upravene.xls set=scenare Rng=a2:a975 rdim=1 set=aktiva Rng=b1:l2 cdim=1 par=vynos Rng=a1:l975 cdim=1 rdim=1 par=tau Rng=a976 rdim=1
$gdxin Industry_portfolios_upravene.gdx
$load scenare
$load aktiva
parameter vynos(scenare, aktiva) nadvynosy v jednotlivych odvetviach = nadvynosy urcitych aktiv za platnosti scenarov;
$load vynos
parameter tau(scenare) nadvynosy trzneho portfolia;
$load tau
$gdxin

* pomocne premenne
parameter A(riadky);
parameter AIndex(riadky);
parameter vynosy(riadky);
parameter vynosyuspor(riadky, aktiva) testovane portfolio;

* zapis modelu ...
positive variables beta(riadky) smernice;
variable theta theta;
variable xi hodnota ucelovej funkcie;

equations
   omezenijedna(aktiva) prve obmedzenie v Postovom kriteriu;
equations xi1 ucelova funkcia;
equations
   omezenibeta(riadky) obmedzenie na klesajuce smernice;
equation poslednebeta obmedzenie na beta_T;

omezenijedna(aktiva)..  (sum(riadky, beta(riadky)*(vynosy(riadky)-vynosyuspor(riadky,aktiva))))/te+theta =g= 0;
omezenibeta(riadky)..   beta(riadky)-beta(riadky+1) =g= 0;
poslednebeta..          beta('riadok120') =e= 1;
xi1..                   xi =e= theta;

model post postova nutna podmienka eficiencie portfolia /xi1, omezenijedna, omezenibeta, poslednebeta/;

* pomocne parametre, ktore su potrebne pri vybere jednotlivych podmatic a riesenie ulohy pre tuto podmaticu
parameter matica(riadky,aktiva);
parameter xjtau(riadky) vektor vynosov pri t roznych scenaroch;
parameter vysledok(vysledkov);
parameter ktory;
parameter v;
parameter j;
parameter i;
parameter k;
v=0;
i=1;
while (i+okienko-1 <= card(scenare),
         ktory = i;
         j=0;
         loop(scenare,
               j=j+1;
               if (j=ktory,
                       k=0;
                       loop(riadky,
                               matica(riadky,aktiva) = vynos(scenare+k,aktiva);
                               xjtau(riadky) = tau(scenare+k);
                       k=k+1;
                       );
               );
         );

A(riadky) = xjtau(riadky);
* write symbol A to GDX file
execute_unload "rank_in.gdx", A;
* sort symbol; permutation index will be named A also
execute 'gdxrank rank_in.gdx rank_out.gdx';
* load the permutation index
execute_load "rank_out.gdx", AIndex=A;
* create a sorted version
vynosy(riadky + (AIndex(riadky)- Ord(riadky))) = A(riadky);
loop(aktiva,vynosyuspor(riadky + (AIndex(riadky)- Ord(riadky)), aktiva) = matica(riadky, aktiva));

solve post minimizing xi using lp;
loop(vysledkov,vysledok(vysledkov+(i-1-(skok-1)*v))=xi.l);
         i=i+skok;
         v=v+1;
);

* zapis vysledkov do Excelu
execute_unload "Post_miera.gdx" vysledok;
execute 'Gdxxrw.exe Post_miera.gdx par=vysledok Rng=a1';
