$TITLE KOPOV TEST
$offsymxref
options limcol=0;
options limrow=5;
options decimals = 8;
set T mnozina scenarov /1*3/;
set scenare mnozina scenarov / scenar1, scenar2, scenar3/;
set aktiva mnozina aktiv /a, b/;
alias(scenare,ind);

table vynos(scenare, aktiva) vynosy aktiv za platnosti scenarov
                a     b
    scenar1     0     1
    scenar2     1     0
    scenar3     0     2;


table vynos2(T, aktiva) vynosy aktiv za platnosti scenarov
                a     b
          1     0     1
          2     1     0
          3     0     2;

parameter te pocet scenarov;
te=card(scenare);

********* zadaj testovane portfolio
parameter tau(aktiva) testovane portfolio
                  /a 0.9, b 0.1/;
parameter xjtau(scenare) vektor vynosov pri T roznych scenaroch;
loop(scenare, xjtau(scenare) = -sum(aktiva, vynos(scenare, aktiva)*tau(aktiva)));
parameter xjtau2(T) vektor vynosov pri T roznych scenaroch;
loop(T, xjtau2(T) = -sum(aktiva, vynos2(T, aktiva)*tau(aktiva)));

parameter A(scenare);
A(scenare) = xjtau(scenare);
display A;
* write symbol A to GDX file
execute_unload "rank_in.gdx", A;
* sort symbol; permutation index will be named A also
execute 'gdxrank rank_in.gdx rank_out.gdx';
* load the permutation index
parameter AIndex(scenare);
execute_load "rank_out.gdx", AIndex=A;
display AIndex;
* create a sorted version
parameter Y(scenare);
Y(scenare + (AIndex(scenare)- Ord(scenare))) = A(scenare);
display Y;

parameter B(T);
B(T) = xjtau2(T);
display B;
execute_unload "rank_in.gdx", B;
* sort symbol; permutation index will be named A also
execute 'gdxrank rank_in.gdx rank_out.gdx';
* load the permutation index
parameter AIndexy(T);
execute_load "rank_out.gdx", AIndexy=B;
display AIndexy;
* create a sorted version
parameter Z(T);
Z(T + (AIndexy(T)- Ord(T))) = B(T);
display Y;
display Z;

parameter indexy(scenare)
                   /scenar1  1, scenar2 2, scenar3 3/;

****** vypocet
positive variables lambda(aktiva) dominujuce portfolio;
positive variables W(scenare, ind) matica W T krat T;
positive variables decka(scenare)  decka;
variables becka(scenare)  becka;

variables d hodnota ucelovej funkcie;
equations
   obmedzenieprve(scenare) prve obmedzenie v Kopovom teste;
equations
    riadky(scenare,ind)  tretie obmedzenie v Kopovom teste;
equations
   sucetlambda     sucet lambda je jedna;
equations d1 ucelova funkcia;

d1.. d =e= sum(scenare, decka(scenare));
obmedzenieprve(scenare).. Y(scenare)+(1/(te-indexy(scenare)+1))*sum(T,Z(T+indexy(scenare-1)))-(1/(te-indexy(scenare)+1))*(te-indexy(scenare)+1)*(Y(scenare))-becka(scenare)-(1/(te-indexy(scenare)+1))*sum(ind,W(scenare,ind)) =g= decka(scenare);
riadky(scenare,ind).. W(scenare, ind) =g= -sum(aktiva, vynos(ind, aktiva)*lambda(aktiva))-becka(scenare);
sucetlambda..    sum(aktiva, lambda(aktiva)) =e= 1;

model kopa Kopov test eficiencie portfolia tau /d1, obmedzenieprve, riadky, sucetlambda/;
solve kopa maximizing d using lp;
display lambda.l;