$TITLE POSTOV TEST - DUALNA ULOHA
$offsymxref
options limcol=0;
options limrow=5;
options decimals = 8;
set scenare mnozina scenarov / scenar1*scenar4/;
set aktiva mnozina aktiv /a, b, c, d/;
table vynos(scenare, aktiva) vynosy aktiv za platnosti scenarov
                a     b    c    d
    scenar1     -3    1    4    3
    scenar2     8     1    -4   2
    scenar3     2     1    1    -3
    scenar4     -1    2    4    3;

parameter te pocet scenarov;
te=card(scenare);

********* zadaj testovane portfolio
parameter tau(aktiva) testovane portfolio
                    /a 0.2, b 0, c 0.1, d 0.7/;

* usporiadanie zloziek vektora vynosov ...
parameter xjtau(scenare) vektor vynosov pri T toznych scenaroch;
loop(scenare, xjtau(scenare) = sum(aktiva, vynos(scenare, aktiva)*tau(aktiva)));
parameter A(scenare);
A(scenare) = xjtau(scenare);
display A;
* write symbol A to GDX file
execute_unload "rank_in.gdx", A;
* sort symbol; permutation index will be named A also
execute 'gdxrank rank_in.gdx rank_out.gdx';
* load the permutation index
parameter AIndex(scenare);
execute_load "rank_out.gdx", AIndex=A;
display AIndex;
* create a sorted version
parameter vynosy(scenare);
vynosy(scenare + (AIndex(scenare)- Ord(scenare))) = A(scenare);
display vynosy;

* usporiadanie riadkov matice X podla poradia zloziek vektora vynosov ...
parameter vynosyuspor(scenare, aktiva) testovane portfolio;
loop(aktiva,vynosyuspor(scenare + (AIndex(scenare)- Ord(scenare)), aktiva) = vynos(scenare, aktiva));
display vynosyuspor;

* vypocet ...
positive variables lambda(aktiva) dominujuce portfolio;
positive variables ro1, ro2, ro3 ciastocne sucty ocekavanych vynosov usporiadanych podla velkosti vzostupne;
variable psi hodnota ucelovej funkcie;

equations
   omezenijedna prve omezeni v Postovom dualnom kriteriu;
equations
   omezenidva druhe omezeni v Postovom dualnom kriteriu;
equations
   omezenitri tretie omezeni v Postovom dualnom kriteriu;

equations
   sucetlambda     sucet lambda je jedna;

equations psi1 ucelova funkcia;

psi1..  psi =e= (sum(aktiva, vynosyuspor('scenar4', aktiva)*lambda(aktiva))-vynosy('scenar4'))/te + ro3;

omezenijedna..  ro1+(vynosy('scenar1')-sum(aktiva, vynosyuspor('scenar1', aktiva)*lambda(aktiva)))/te =l= 0;
omezenidva..  ro2-ro1+(vynosy('scenar2')-sum(aktiva, vynosyuspor('scenar2', aktiva)*lambda(aktiva)))/te =l= 0;
omezenitri..  ro3-ro2+(vynosy('scenar3')-sum(aktiva, vynosyuspor('scenar3', aktiva)*lambda(aktiva)))/te =l= 0;

sucetlambda..    sum(aktiva, lambda(aktiva)) =e= 1;

model postdualny Postov test eficiencie portfolia tau /psi1, omezenijedna, omezenidva, omezenitri, sucetlambda/;
solve postdualny maximizing psi using lp;
display lambda.l;