$TITLE KUOSMANENOV TEST
$offsymxref
options limcol=0;
options limrow=5;
options decimals = 8;
set scenare mnozina scenarov / scenar1*scenar3/;
set aktiva mnozina aktiva /a, b, c, d/;
alias(scenare,ind);
table vynos(scenare, aktiva) vynosy aktiv za platnosti scenarov
                a    b    c    d
    scenar1     0    2    0    1
    scenar2     3    3    5    4
    scenar3     4    4    5    5;


parameter te pocet scenarov;
te=card(scenare);

***** zadaj testovane portfolio
parameter tau(aktiva) testovane portfolio
                 /a 0.5, b 0.5, c 0, d 0/;

parameter xjtau(ind) vektor vynosov pri T roznych scenaroch;
loop(scenare, xjtau(scenare) = sum(aktiva, vynos(scenare, aktiva)*tau(aktiva)));


positive variables lambda(aktiva) dominujuce portfolio;
positive variables W(scenare,ind) matica W T krat T;



variable thetaN hodnota ucelovej funkcie;
equations
   obmedzenieprve(scenare) prve obmedzenie v Kuosmanenovom teste;
equations
   stlpceW(ind)   sucet v stlpcoch W je jedna;
equations
   riadkyW(scenare)   sucet v riadkoch W je jedna;
equations
   sucetlambda     sucet lambda je jedna;
equations thetaN1 ucelova funkcia;


thetaN1..  thetaN =e= sum(scenare, sum (aktiva, vynos(scenare, aktiva)*lambda(aktiva))-xjtau(scenare))/te;
obmedzenieprve(scenare)..  sum(aktiva, vynos(scenare, aktiva)*lambda(aktiva)) =g= sum(ind, W(scenare, ind)*xjtau(ind));
stlpceW(ind)..  sum(scenare, W(scenare, ind)) =e= 1;
riadkyW(scenare)..  sum(ind, W(scenare, ind)) =e= 1;
sucetlambda..    sum(aktiva, lambda(aktiva)) =e= 1;

model kuosmanen Kuosmanenov test eficiencie portfolia tau /thetaN1, obmedzenieprve, stlpceW, riadkyW, sucetlambda/;
solve kuosmanen maximizing thetaN using lp;
display lambda.l;
display W.L;